;     Interrupt handlers.
;       This is not a good example of how coding a good keyboard handler
;      but it works !!
;
;                             Fernando Anton - Mitra / Spanish Lords
;                                                  fernando@ergos.es
    JUMPS
    LOCALS  @@
   .386



; Little macro to manage the extended keyboard codes.
DoExt   MACRO  Val1,Val2

	CMP    BL,Val1
	JNE    @@Lab&&Val2
	MOV    BL,Val2
	JMP    @@HazExt
  @@Lab&&Val2:

	ENDM

; 16 bits segment needed for the real mode interrupt.
_TEXT16 SEGMENT BYTE PUBLIC USE16 'CODE'
 ASSUME  cs:_TEXT16

	       PUBLIC SLRInt9_
      SLRInt9_ PROC

	PUSH   AX
	PUSH   BX

	XOR    AX,AX

	IN     AL,60h
	PUSH   AX
	IN     AL,61h
	MOV    AH,AL
	OR     AL,80h
	OUT    61h,AL    ; Send "key processed" to keyboard controller
	POP    AX

	MOV    BX,AX

	CMP    BYTE PTR CS:[254],0E0h   ; Is an extended char ?
        JNE    @@NoExt
  @@EsExt:

	AND    BX,127

	DoExt  38h,70h        ; Right Alt
	DoExt  1Dh,71h        ; Right Ctrl
	DoExt  1Ch,7Ch        ; Gray Intro
	DoExt  35h,7Dh        ; Gray Bar
   ; Estos van precedidos de E0/2A ... E0/AA
	DoExt  52h,72h        ; Gray Insert
	DoExt  53h,73h        ; Gray Del
	DoExt  47h,74h        ; Gray Home
	DoExt  4Fh,75h        ; Gray End
	DoExt  49h,76h        ; Gray Page Up
	DoExt  51h,77h        ; Gray Page Down
	DoExt  48h,78h        ; Up Arrow
	DoExt  50h,79h        ; Down Arrow
	DoExt  4Bh,7Ah        ; Left Arrow
	DoExt  4Dh,7Bh        ; Right Arrow
	DoExt  37h,7Fh        ; Print Screen
	JMP    @@end

  @@HazExt:
	AND    AX,128
	JZ     @@Pulsada
	MOV    BYTE PTR CS:[BX],0  ; If bit 7=1 key depressed.
	JMP    @@end

  @@NoExt:
	CMP    BL,0E1h             ; Pause key ?
	JNE    @@NoPause
	INC    BYTE PTR CS:[7Eh]
	JMP    @@end

  @@NoPause:
	CMP    BL,0E0h             ; Extended char code ?
	JE     @@end

	AND    BX,127
	AND    AX,128              ; Pressed or depressed ?
	JZ     @@Pulsada
	MOV    BYTE PTR CS:[BX],0
	JMP    @@end
  @@Pulsada:
	INC    BYTE PTR CS:[253]   ; Keyboard commands counter.
	MOV    BYTE PTR CS:[BX],1
  @@end:

	MOV    CS:[254],BL         ; Last keyboard command.

	MOV    AX,20h              ; End Of Interrupt
	OUT    20h,AL

	POP    BX
	POP    AX

	IRET

      SLRInt9_ ENDP

      db 4096 dup(0)

_TEXT16 ENDS


   .386P   ; Protected mode

_DATA   SEGMENT BYTE PUBLIC USE32 'DATA'

      EXTRN _Teclas    ; far unsigned char* to DOS memory.

_DATA   ENDS
DGROUP GROUP _DATA

; 32 bits segment for PM interrupt.
; PM interrupt is equal to RM interrupt, but when you access the DOS
; memory zone you must have a selector and an offset (ES:ESI)
_TEXT   SEGMENT BYTE PUBLIC USE32 'CODE'
 ASSUME  cs:_TEXT,ds:_DATA

	      PUBLIC SLInt9_
      SLInt9_ PROC

	PUSH   DS
	PUSH   ES
	PUSH   ESI
	PUSH   EAX
	PUSH   EBX

	MOV    BX,DGROUP
	XOR    EAX,EAX
	MOV    DS,BX

	IN     AL,60h
	PUSH   EAX
	IN     AL,61h
	MOV    AH,AL
	OR     AL,80h
	OUT    61h,AL
	POP    EAX

	LES    ESI,FWORD PTR _Teclas
	MOV    EBX,EAX

	CMP    BYTE PTR ES:[ESI+254],0E0h
	JNE    @@NoExt
  @@EsExt:

	AND    EBX,127

	DoExt  38h,70h
	DoExt  1Dh,71h
	DoExt  1Ch,7Ch
	DoExt  35h,7Dh
	DoExt  52h,72h
	DoExt  53h,73h
	DoExt  47h,74h
	DoExt  4Fh,75h
	DoExt  49h,76h
	DoExt  51h,77h
	DoExt  48h,78h
	DoExt  50h,79h
	DoExt  4Bh,7Ah
	DoExt  4Dh,7Bh
	DoExt  37h,7Fh
	JMP    @@end
  @@HazExt:
	AND    EAX,128
	JZ     @@Pulsada
	MOV    BYTE PTR ES:[ESI+EBX],0
	JMP    @@end
  @@NoExt:
	CMP    BL,0E1h
	JNE    @@NoPause
	INC    BYTE PTR ES:[ESI+7Eh]
	JMP    @@end

  @@NoPause:
	CMP    BL,0E0h
	JE     @@end
	AND    EBX,127
	AND    EAX,128
	JZ     @@Pulsada
	MOV    BYTE PTR ES:[ESI+EBX],0
	JMP    @@end
  @@Pulsada:
	INC    BYTE PTR ES:[ESI+253]
	MOV    BYTE PTR ES:[ESI+EBX],1
  @@end:
	MOV    ES:[ESI+254],BL

	MOV    EAX,20h
	OUT    20h,AL

	POP    EBX
	POP    EAX
	POP    ESI
	POP    ES
	POP    DS

	IRETD

      SLInt9_ ENDP

_TEXT   ENDS


	END
