//     Defines used as array index.
//
//                             Fernando Anton - Mitra / Spanish Lords
//                                                  fernando@ergos.es

#ifndef _SLKEYS_H_
#define _SLKEYS_H_

// Pause key is not so well detected.. The array counter only gets
// incremented each time you press or depress it. It's not well
// done because some keyboards send E1/1D/45/E1/9D/C5 .
// If anyone knows something about this, please mail me.
#define kbPause    0x7E

// Special chars.
#define kbEsc      0x01
#define kbBack     0x0E
#define kbTab      0x0F
#define kbCapsLock 0x3A
#define kbIntro    0x1C
#define kbLShift   0x2A
#define kbRShift   0x36
#define kbSpace    0x39
#define kbLAlt     0x38
#define kbLCtrl    0x1D
#define kbScrLock  0x46

// If you don't have an Spanish keyboard, these keys will change,
#define kbPoint    0x34  // . :
#define kbComma    0x33  // , ;
#define kbMinus    0x35  // - _
#define kbLKey     0x28  //   {
#define kbRKey     0x2B  //   }
#define kbLBracket 0x1A  // ^ ` [
#define kbRBracket 0x1B  // * + ]
#define kbKey     0x27
#define kbInvBar   0x29  //  
#define kbAsk      0x0C  // ' ?
#define kbInvAsk   0x0D  //  

// Chars preceded by E0. Some keyboards send E0/2A/E0/xx/E0/xx/E0/AA, but
// that has been fixed.

#define kbPrintScr 0x7F

#define kbInsert   0x72
#define kbDel      0x73
#define kbHome     0x74
#define kbEnd      0x75
#define kbPageUp   0x76
#define kbPageDown 0x77

#define kbUp       0x78
#define kbDown     0x79
#define kbLeft     0x7A
#define kbRight    0x7B

// Chars preceded by E0
#define kbRAlt     0x70
#define kbRCtrl    0x71

#define kbGIntro   0x7C   // El Enter del KeyPad.
#define kbGBar     0x7D   // /  del KeyPad.

// Keypad
#define kbNumLock  0x45
#define kbAsterisk 0x37
#define kbGMinus   0x4A
#define kbGPlus    0x4E
#define kbGNum7    0x47
#define kbGNum8    0x48
#define kbGNum9    0x49
#define kbGNum4    0x4B
#define kbGNum5    0x4C
#define kbGNum6    0x4D
#define kbGNum1    0x4F
#define kbGNum2    0x50
#define kbGNum3    0x51
#define kbGNum0    0x52
#define kbGPoint   0x53

// Function keys.
#define kbF1       0x3B
#define kbF2       0x3C
#define kbF3       0x3D
#define kbF4       0x3E
#define kbF5       0x3F
#define kbF6       0x40
#define kbF7       0x41
#define kbF8       0x42
#define kbF9       0x43
#define kbF10      0x44
#define kbF11      0x57
#define kbF12      0x58

// Numbers.
#define kbNum1     0x02
#define kbNum2     0x03
#define kbNum3     0x04
#define kbNum4     0x05
#define kbNum5     0x06
#define kbNum6     0x07
#define kbNum7     0x08
#define kbNum8     0x09
#define kbNum9     0x0A
#define kbNum0     0x0B

// Alphabet.
#define kbKeyQ     0x10
#define kbKeyW     0x11
#define kbKeyE     0x12
#define kbKeyR     0x13
#define kbKeyT     0x14
#define kbKeyY     0x15
#define kbKeyU     0x16
#define kbKeyI     0x17
#define kbKeyO     0x18
#define kbKeyP     0x19

#define kbKeyA     0x1E
#define kbKeyS     0x1F
#define kbKeyD     0x20
#define kbKeyF     0x21
#define kbKeyG     0x22
#define kbKeyH     0x23
#define kbKeyJ     0x24
#define kbKeyK     0x25
#define kbKeyL     0x26

#define kbKeyZ     0x2C
#define kbKeyX     0x2D
#define kbKeyC     0x2E
#define kbKeyV     0x2F
#define kbKeyB     0x30
#define kbKeyN     0x31
#define kbKeyM     0x32


#endif